"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var TransferModule_1, TransferModuleForUnitTest_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransferModuleForUnitTest = exports.TransferModule = void 0;
const origin_247_certificate_1 = require("@energyweb/origin-247-certificate");
const common_1 = require("@nestjs/common");
const cqrs_1 = require("@nestjs/cqrs");
const typeorm_1 = require("@nestjs/typeorm");
const GenerationReadingStoredEvent_handler_1 = require("./handlers/GenerationReadingStoredEvent.handler");
const CertificatePersistedEvent_handler_1 = require("./handlers/CertificatePersistedEvent.handler");
const repositories_1 = require("./repositories");
const transfer_service_1 = require("./transfer.service");
const ValidateTransferCommand_1 = require("./commands/ValidateTransferCommand");
const handlers_1 = require("./handlers");
const UpdateTransferValidationCommand_handler_1 = require("./handlers/UpdateTransferValidationCommand.handler");
let TransferModule = TransferModule_1 = class TransferModule {
    static register(params) {
        return {
            module: TransferModule_1,
            providers: [
                GenerationReadingStoredEvent_handler_1.GenerationReadingStoredEventHandler,
                CertificatePersistedEvent_handler_1.CertificatePersistedEventHandler,
                transfer_service_1.TransferService,
                handlers_1.ValidatedTransferRequestEventHandler,
                UpdateTransferValidationCommand_handler_1.UpdateTransferValidationCommandHandler,
                {
                    provide: repositories_1.ENERGY_TRANSFER_REQUEST_REPOSITORY,
                    useClass: repositories_1.EnergyTransferRequestPostgresRepository
                },
                {
                    provide: ValidateTransferCommand_1.VALIDATE_TRANSFER_COMMANDS_TOKEN,
                    useValue: params.validateCommands
                }
            ],
            imports: [
                typeorm_1.TypeOrmModule.forFeature([repositories_1.EnergyTransferRequestEntity]),
                cqrs_1.CqrsModule,
                origin_247_certificate_1.CertificateModule
            ]
        };
    }
};
TransferModule = TransferModule_1 = __decorate([
    common_1.Module({})
], TransferModule);
exports.TransferModule = TransferModule;
let TransferModuleForUnitTest = TransferModuleForUnitTest_1 = class TransferModuleForUnitTest {
    static register(params) {
        return {
            module: TransferModuleForUnitTest_1,
            providers: [
                GenerationReadingStoredEvent_handler_1.GenerationReadingStoredEventHandler,
                CertificatePersistedEvent_handler_1.CertificatePersistedEventHandler,
                transfer_service_1.TransferService,
                handlers_1.ValidatedTransferRequestEventHandler,
                UpdateTransferValidationCommand_handler_1.UpdateTransferValidationCommandHandler,
                {
                    provide: repositories_1.ENERGY_TRANSFER_REQUEST_REPOSITORY,
                    useClass: repositories_1.EnergyTransferRequestInMemoryRepository
                },
                {
                    provide: ValidateTransferCommand_1.VALIDATE_TRANSFER_COMMANDS_TOKEN,
                    useValue: params.validateCommands
                }
            ],
            imports: [cqrs_1.CqrsModule, origin_247_certificate_1.CertificateForUnitTestsModule]
        };
    }
};
TransferModuleForUnitTest = TransferModuleForUnitTest_1 = __decorate([
    common_1.Module({})
], TransferModuleForUnitTest);
exports.TransferModuleForUnitTest = TransferModuleForUnitTest;
//# sourceMappingURL=transfer.module.js.map