import { CertificateService } from '@energyweb/origin-247-certificate';
import { EnergyTransferRequestRepository } from './repositories/EnergyTransferRequest.repository';
import { GenerationReadingStoredPayload } from './events/GenerationReadingStored.event';
import { QueryBus, CommandBus, EventBus } from '@nestjs/cqrs';
import { ValidateTransferCommandCtor } from './commands/ValidateTransferCommand';
import { TransferValidationStatus } from './EnergyTransferRequest';
interface IIssueCommand extends GenerationReadingStoredPayload<unknown> {
}
export interface IUpdateValidationStatusCommand {
    requestId: number;
    status: TransferValidationStatus;
    validatorName: string;
}
export declare class TransferService {
    private certificateService;
    private energyTransferRequestRepository;
    private validateCommands;
    private queryBus;
    private commandBus;
    private eventBus;
    private readonly logger;
    constructor(certificateService: CertificateService<unknown>, energyTransferRequestRepository: EnergyTransferRequestRepository, validateCommands: ValidateTransferCommandCtor[], queryBus: QueryBus, commandBus: CommandBus, eventBus: EventBus);
    issue(command: IIssueCommand): Promise<void>;
    persistRequestCertificate(certificateId: number): Promise<void>;
    private startValidation;
    updateValidationStatus(command: IUpdateValidationStatusCommand): Promise<void>;
    transferCertificate(requestId: number): Promise<void>;
    private executeCommand;
}
export {};
